local f1 = CreateFrame("Frame",nil,UIParent,"UIPanelDialogTemplate")
f1:SetWidth(192)
f1:SetHeight(256)
f1:SetAlpha(.90)
f1:SetPoint("CENTER",-200,220)
f1:SetMovable(true)
f1:EnableMouse(true)
f1:SetClampedToScreen(true)
f1:RegisterForDrag("RightButton")
f1:RegisterEvent("UNIT_HEALTH_FREQUENT")
f1:RegisterEvent("UNIT_POWER_FREQUENT")
f1:RegisterEvent("UNIT_TARGET")
f1:RegisterEvent("UNIT_COMBAT")
f1:RegisterEvent("QUEST_DETAIL")
f1:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
f1:SetScript("OnDragStart", f1.StartMoving)
f1:SetScript("OnDragStop", f1.StopMovingOrSizing)
f1:SetScript("OnEvent", function(self, event, ...)
	if(event == "UNIT_HEALTH_FREQUENT") then
		ShowStats()
	end
	if(event == "UNIT_POWER_FREQUENT") then
		ShowStats()
	end
	if(event == "UNIT_TARGET") then
		arg1, arg2, arg3, arg4, arg5 = ...
		UpdateCombat(self, arg2, arg3, arg4, arg5)
		ShowStats()
	end
	if(event == "UNIT_COMBAT") then
		arg6, arg7, arg8, arg9, arg10 = ...
		ReceiveStatus(self, arg7, arg8, arg9, arg10)
		ShowStats()
	end
	if(event == "COMBAT_LOG_EVENT_UNFILTERED") then
		SendStatus(self, CombatLogGetCurrentEventInfo())
		ShowStats()
	end
	if(event == "QUEST_DETAIL") then
		AcceptQuest()
	end
end)
local t1 = f1:CreateFontString(nil, "OVERLAY", "GameFontNormalSmall")
t1:SetPoint("TOPLEFT", 20, -12)
t1:SetWidth(154)
t1:SetHeight(234)
t1:SetJustifyH("LEFT")
local t2 = f1:CreateFontString(nil, "OVERLAY", "GameFontNormalSmall")
t2:SetPoint("TOPLEFT", 20, -12)
t2:SetWidth(154)
t2:SetHeight(234)
t2:SetJustifyH("RIGHT")
f1:Show()

local f2 = CreateFrame("Frame",nil,UIParent,"TooltipBorderedFrameTemplate")
f2:SetWidth(256)
f2:SetHeight(144)
f2:SetAlpha(.90)
f2:SetPoint("CENTER",0,0)
f2:SetMovable(true)
f2:EnableMouse(true)
f2:SetClampedToScreen(true)
f2:RegisterForDrag("RightButton")
f2:SetScript("OnMouseDown", function (self, button)
	if(button == "LeftButton") then
		ResetAllAreas()
	end
end)
f2:SetScript("OnDragStart", f2.StartMoving)
f2:SetScript("OnDragStop", f2.StopMovingOrSizing)
local t3 = f2:CreateFontString(nil, "OVERLAY", "GameFontNormalSmall")
t3:SetPoint("TOPLEFT", 20, -4)
t3:SetWidth(216)
t3:SetHeight(136)
t3:SetJustifyH("LEFT")
local t4 = f2:CreateFontString(nil, "OVERLAY", "GameFontNormalSmall")
t4:SetPoint("TOPLEFT", 20, -4)
t4:SetWidth(216)
t4:SetHeight(136)
t4:SetJustifyH("RIGHT")
f2:Show()

local f3 = CreateFrame("Frame",nil,UIParent,"UIPanelDialogTemplate")
f3:SetWidth(192)
f3:SetHeight(316)
f3:SetAlpha(.90)
f3:SetPoint("CENTER",0,200)
f3:SetMovable(true)
f3:EnableMouse(true)
f3:SetClampedToScreen(true)
f3:RegisterForDrag("RightButton")
f3:SetScript("OnDragStart", f2.StartMoving)
f3:SetScript("OnDragStop", f2.StopMovingOrSizing)
local t6 = f3:CreateFontString(nil, "OVERLAY", "GameFontNormalSmall")
t6:SetPoint("TOPLEFT", 20, -6)
t6:SetWidth(154)
t6:SetHeight(304)
t6:SetJustifyH("LEFT")
f3:Show()

pHealAmount, pHealCount, pDamageAmount, pDamageCount = 0, 0, 0, 0
pRangeAmount, pRangeCount, pSwingAmount, pSwingCount = 0, 0, 0, 0
pSpellAmount, pSpellCount, pHeal, pDamage, pMissCount = 0, 0, 0, 0, 0

function ResetAllAreas()
	pHealAmount = 0
	pHealCount = 0
	pDamageAmount = 0
	pDamageCount = 0
	pRangeAmount = 0
	pRangeCount = 0
	pSwingAmount = 0
	pSwingCount  = 0
	pSpellAmount = 0
	pSpellCount = 0
	pMissCount = 0
	pHeal = 0
	pDamage = 0
	f1:Show()
	f3:Show()
end

function SendStatus(self, ...)
	playerUsed = UnitGUID("player")
	targetUsed = UnitGUID("target")
	_, eventtype, _, sourceGUID, _, _, _, destGUID, _, _, _ = ...
	if(sourceGUID == playerUsed) then
		if(eventtype == "SWING_DAMAGE") then
			amount, overkill, school, resisted, blocked, absorbed, critical, glancing, curshing, isOffHand = select(12, ...)
			pSwingCount = pSwingCount + 1
			pSwingAmount = pSwingAmount + amount
		end
		if(eventtype == "SPELL_DAMAGE") then
			spellId, spellName, spellSchool, spellamount, spelloverkill, pschool, presisted, pblocked, pabsorbed, pcritical, pglancing, pcurshing, pisOffHand = select(12, ...)
			pSpellCount = pSpellCount + 1
			pSpellAmount = pSpellAmount + spellamount
		end
		if(eventtype == "SPELL_PERIODIC_DAMAGE") then
			spellId, spellName, spellSchool, spellamount, spelloverkill, pschool, presisted, pblocked, pabsorbed, pcritical, pglancing, pcurshing, pisOffHand = select(12, ...)
			pSpellCount = pSpellCount + 1
			pSpellAmount = pSpellAmount + spellamount
		end
		if(eventtype == "RANGE_DAMAGE") then
			rangeId, rangeName, rangeSchool, rangeamount, rangeoverkill, rschool, rresisted, rblocked, rabsorbed, rcritical, rglancing, rcurshing, risOffHand = select(12, ...)
			pRangeCount = pRangeCount + 1
			pRangeAmount = pRangeAmount + rangeamount
		end
		if(eventtype == "SWING_MISSED") then
			pMissCount = pMissCount + 1
		end
		if(eventtype == "SPELL_MISSED") then
			pMissCount = pMissCount + 1
		end
		if(eventtype == "RANGE_MISSED") then
			pMissCount = pMissCount + 1
		end
	end
	if(destGUID == playerUsed) then
		if(eventtype == "SWING_DAMAGE") then
			amount, overkill, school, resisted, blocked, absorbed, critical, glancing, curshing, isOffHand = select(12, ...)
			pDamageCount = pDamageCount + 1
			pDamageAmount = pDamageAmount + amount
		end
		if(eventtype == "SPELL_DAMAGE") then
			spellId, spellName, spellSchool, spellamount, spelloverkill, pschool, presisted, pblocked, pabsorbed, pcritical, pglancing, pcurshing, pisOffHand = select(12, ...)
			pDamageCount = pDamageCount + 1
			pDamageAmount = pDamageAmount + spellamount
		end
		if(eventtype == "SPELL_PERIODIC") then
			spellId, spellName, spellSchool, spellamount, spelloverkill, pschool, presisted, pblocked, pabsorbed, pcritical, pglancing, pcurshing, pisOffHand = select(12, ...)
			pDamageCount = pDamageCount + 1
			pDamageAmount = pDamageAmount + spellamount
		end
		if(eventtype == "RANGE_DAMAGE") then
			rangeId, rangeName, rangeSchool, rangeamount, rangeoverkill, rschool, rresisted, rblocked, rabsorbed, rcritical, rglancing, rcurshing, risOffHand = select(12, ...)
			pDamageCount = pDamageCount + 1
			pDamageAmount = pDamageAmount + rangeamount
		end
		if(eventtype == "SWING_MISSED") then
			pDamageCount = pDamageCount + 1
		end
		if(eventtype == "SPELL_MISSED") then
			pDamageCount = pDamageCount + 1
		end
		if(eventtype == "RANGE_MISSED") then
			pDamageCount = pDamageCount + 1
		end
	end
end

function ReceiveStatus(self, event, flags, amount, type)
	if(event == "HEAL") then
		pHealCount = pHealCount + 1
		pHealAmount = pHealAmount + amount
	end
end

function UpdateCombat()
	mHealth = UnitHealth("target")
	mMana = UnitPower("target")
	pTotal, pSwingAvg, pRangeAvg, pSpellAvg = 0, 0, 0, 0, 0, 0
	pTotalAmount = pSpellAmount + pSwingAmount + pRangeAmount
	pTotalCount = pSpellCount + pSwingCount + pRangeCount + pMissCount
	if(pDamageCount > 0) then
		pDamage = pDamageAmount / pDamageCount
	end
	if(pSwingCount > 0) then
		pSwingAvg = pSwingAmount / pSwingCount
	end
	if(pRangeCount > 0) then
		pRangeAvg = pRangeAmount / pRangeCount
	end
	if(pSpellCount > 0) then
		pSpellAvg = pSpellAmount / pSpellCount
	end
	if(pTotalCount > 0) then
		pTotal = pTotalAmount / pTotalCount
	end
	if(pHealCount > 0) then
		pHeal = pHealAmount / pHealCount
	end
	vText = "Health\nPower\n\nMissed\nSwing\nSpell\nRange\n\nTotal\nHeal\nDamage\n"
	rText = mHealth .. "\n" .. mMana .. "\n\n" .. pMissCount .. "\n" .. pSwingCount .. " : " .. format("%.0f", pSwingAvg) .. "\n" .. pSpellCount .. " : " .. format("%.0f", pSpellAvg) .. "\n" .. pRangeCount .. " : " .. format("%.0f", pRangeAvg) .. "\n\n" .. pTotalCount .. " : " .. format("%.0f", pTotal) .. "\n" .. pHealCount .. " : " .. format("%.0f", pHeal) .. "\n" .. pDamageCount .. " : " .. format("%.0f", pDamage)
	t3:SetText(vText)
	t4:SetText(rText)
end

function UpdateStats()
	pHealth = UnitHealth("player")
	pMana = UnitPower("player")
	pCrit = format("%.2f%%", GetCritChance())
	sCrit = format("%.2f%%", GetSpellCritChance())
	rCrit = format("%.2f%%", GetRangedCritChance())
	pHit, base = GetManaRegen()
	cSpeed, rSpeed, fSpeed, sSpeed = GetUnitSpeed("player")
	bPwr, pPwr, nPwr = UnitAttackPower("player")
	rbPwr, rpPwr, rnPwr = UnitRangedAttackPower("player")
	ePwr = bPwr + pPwr + nPwr
	rePwr = rbPwr + rpPwr + rnPwr
	vText = "Health\nPower\n\nAttack\nRanged\n\nMelee Crit\nSpell Crit\nRanged Crit\n\nMana Regen\nCombat Regen\nMove Speed"
	rText = pHealth .. "\n" .. pMana .. "\n\n" .. ePwr .. "\n" .. rePwr .. "\n\n" .. pCrit .. "\n" .. sCrit .. "\n" .. rCrit .. "\n\n" .. format("%.2f", (base * 2)) .. "\n" .. format("%.2f", (pHit * 2)) .. "\n" .. cSpeed
	t1:SetText(vText)
	t2:SetText(rText)
end

function UpdateZone()
	pLvl = UnitLevel("player")
	pExp = UnitXP("player")
	pExpMax = UnitXPMax("player")
	pDungeonArea = "None"
	tExp = pExpMax - pExp
	pXPLvl = ((pLvl * 5) + 45)
	tExpCount = tExp / pXPLvl
	pZoneArea = "Zones\n\n"
	pDungeonArea = "Dungeons\n\n"
	if(pLvl < 10) then
		pZoneArea = "Dun Morogh\nDurotar\nElwynn Forest\nMulgore\nTeldrassil\nTirisfal Glades "
	end
	if(pLvl > 9) then
		if(pLvl < 26) then
			pZoneArea = "Zones\n\nBarrens"
		end
	end
	if(pLvl > 9) then
		if(pLvl < 19) then
			pZoneArea = pZoneArea .. "\n" .. "Darkshore\nLock Modan\nSilverpine Forest\nWestfall"
		end
		if(pLvl > 14) then
			if(pLvl < 26) then
				pZoneArea = pZoneArea .. "\n" .. "Redridge Mountains"
			end
			if(pLvl < 28) then
				pZoneArea = pZoneArea .. "\n" .. "Stonetalon Mountains"
			end
		end
		if(pLvl > 17) then
			if(pLvl < 31) then
				pZoneArea = pZoneArea .. "\n" .. "Ashenvale"
			end
			if(pLvl < 31) then
				pZoneArea = pZoneArea .. "\n" .. "Duskwood"
			end
		end
		if(pLvl > 19) then
			if(pLvl < 31) then
				pZoneArea = pZoneArea .. "\n" .. "Hillsbrad Foothills"
			end
			if(pLvl < 31) then
				pZoneArea = pZoneArea .. "\n" .. "Wetlands"
			end
		end
	end
	if(pLvl > 24) then
		if(pLvl < 36) then
			pZoneArea = "Zones\n\nThousand Needles"
		end
		if(pLvl < 31) then
			pZoneArea = pZoneArea .. "\n" .. "Hillsbrad Foothills"
		end
		if(pLvl < 31) then
			pZoneArea = pZoneArea .. "\n" .. "Wetlands"
		end
		if(pLvl < 26) then
			pZoneArea = pZoneArea .. "\n" .. "Redridge Mountains"
			end
		if(pLvl < 28) then
			pZoneArea = pZoneArea .. "\n" .. "Stonetalon Mountains"
		end
		if(pLvl < 31) then
			pZoneArea = pZoneArea .. "\n" .. "Ashenvale"
		end
		if(pLvl < 31) then
			pZoneArea = pZoneArea .. "\n" .. "Duskwood"
		end
	end
	if(pLvl > 30) then
		if(pLvl < 46) then
			pZoneArea = pZoneArea .. "\n" .. "Stranglethorn Vale"
			if(pLvl > 34) then
				pZoneArea = pZoneArea .. "\n" .. "Duskwallow Marsh\nBadlands\nSwamp of Sorrows"
			end
		end
		if(pLvl < 41) then
			pZoneArea = pZoneArea .. "\n" .. "Alterac Mountains\nArathi Highlands\nDesolace"
		end
	end
	if(pLvl > 39) then
		if(pLvl < 51) then
			pZoneArea = "Zones\n\nFeralas\nHinterlands\nTanaris"
		end
		if(pLvl < 46) then
			pZoneArea = pZoneArea .. "\n" .. "Stranglethorn Vale"
		end
		if(pLvl > 44) then
			pZoneArea = pZoneArea .. "\n" .. "Searing Gorge"
		end
	end
	if(pLvl > 44) then
		if(pLvl < 59) then
			pZoneArea = "Zones\n\nAzshara\nBlasted Lands\nUn'goro Crater\nFelwood\nBurning Steppes\nWestern Plaguelands"
		end
		if(pLvl < 51) then
			pZoneArea = pZoneArea .. "\n" .. "Searing Gorge"
		end	
	end
	if(pLvl > 52) then
		pZoneArea = "Zones\n\nEastern Plaguelands\nWinterspring\nDeadwing Pass\nMoonglade\nSilithus"
		if(pLvl < 59) then
			pZoneArea = pZoneArea .. "\n" .. "Burning Steppes\nWestern Plaguelands"
		end	
	end
	
	if(pLvl > 12) then
		if(pLvl < 19) then
			pDungeonArea = pDungeonArea .. "Ragefire Chasm (Horde) (RFC)"
		end
	end
	if(pLvl > 16) then
		if(pLvl < 25) then
			pDungeonArea = pDungeonArea .. "\n" .. "Wailing Caverns (WC)"
		end
		if(pLvl < 27) then
			pDungeonArea = pDungeonArea .. "\n" .. "The Deadmines (Alliance) (VC)"
		end
	end
	if(pLvl > 21) then
		if(pLvl < 30) then
			pDungeonArea = pDungeonArea .. "\n" .. "Shadowfang Keep (SFK)"
		end
	end
	if(pLvl > 24) then
		if(pLvl < 32) then
			pDungeonArea = pDungeonArea .. "\n" .. "Blackfathom Deeps (BFD)\nThe Stockade (Alliance) (Stocks)"
		end
	end
	if(pLvl > 28) then
		if(pLvl < 39) then
			pDungeonArea = pDungeonArea .. "\n" .. "Gnomeregan (Gnomer)\nRazorfen Kraul (RFK)"
			if(pLvl > 32) then
				pDungeonArea = "Dungeons\n\n" .. "Gnomeregan (Gnomer)\nRazorfen Kraul (RFK)"
			end
		end
	end
	if(pLvl > 33) then
		if(pLvl < 45) then
			pDungeonArea = pDungeonArea .. "\n" .. "The Scarlet Monastery (SM)"
		end
	end
	if(pLvl > 36) then
		if(pLvl < 47) then
			pDungeonArea = pDungeonArea .. "\n" .. "Razorfen Downs (RFD)"
		end
	end
	if(pLvl > 40) then
		if(pLvl < 52) then
			pDungeonArea = pDungeonArea .. "\n" .. "Uldaman (ULD)"
		end
	end
	if(pLvl > 41) then
		if(pLvl < 47) then
			pDungeonArea = pDungeonArea .. "\n" .. "Zul'Farrak (ZF)"
		end
	end
	if(pLvl > 45) then
		if(pLvl < 56) then
			pDungeonArea = pDungeonArea .. "\n" .. "Maraudon (MARA)"
		end
	end
	if(pLvl > 49) then
		if(pLvl < 57) then
			pDungeonArea = pDungeonArea .. "\n" .. "Temple of Atal'Hakkar (ST)"
		end
	end
	if(pLvl > 51) then
		if(pLvl < 61) then
			pDungeonArea = pDungeonArea .. "\n" .. "Blackrock Depths (BRD)"
			if(pLvl > 56) then
				pDungeonArea = "Dungeons\n\n" .. "Blackrock Depths (BRD)"
			end
		end
	end
	if(pLvl > 54) then
		if(pLvl < 61) then
			pDungeonArea = pDungeonArea .. "\n" .. "Lower Blackrock Spire (LBRS)\nDiremaul (DM)\nUpper Blackrock Spire (10) (UBRS)"
			if(pLvl > 58) then
				pDungeonArea = pDungeonArea .. "\n" .. "Stratholme (STRAT)\nScholomance (SCHOLO)"
			end
		end
	end
	qText = "Next level\n\n" .. format("%.0f", tExpCount) .. " Lvl " .. pLvl .. " NPC at " .. pXPLvl .. " xp\n" .. tExp .. " xp\n\n" .. pZoneArea .. "\n\n" .. pDungeonArea
	t6:SetText(qText)
end


function ShowStats()
	UpdateStats()
	UpdateCombat()
	UpdateZone()
end

MainMenuBarLeftEndCap:Hide()
MainMenuBarRightEndCap:Hide()






